Imports System.ComponentModel
Imports System.Drawing
Imports System.WinForms
Imports System.Threading
Imports Microsoft.VisualBasic.Compatibility.VB6


Public Class Form1
    Inherits System.WinForms.Form
    
    ' Le thread de calcul
    Dim thrCalcul As New Threading.Thread(AddressOf Calcul)
    ' Le thread d'exploitation des rsultats
    Dim thrExploite As New Threading.Thread(AddressOf Exploite)
    
    ' Le mutex de synchronisation
    Dim MonMutex As New Mutex()
    
    ' Les donnes partages
    Dim Tableau(1001) As Double
    
    Public Sub New()
        MyBase.New

        Form1 = Me

        'This call is required by the Win Form Designer.
        InitializeComponent

        'TODO: Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Overrides Public Sub Dispose()
        MyBase.Dispose
        components.Dispose()
        
        ' Termine les threads
        On Error Resume Next
        thrCalcul.Stop()
        thrExploite.Stop()
    End Sub 

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents cmdDemarrer As System.WinForms.Button
    
    
    Private WithEvents lst As System.WinForms.ListBox
    
    Dim WithEvents Form1 As System.WinForms.Form

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.lst = New System.WinForms.ListBox()
        Me.cmdDemarrer = New System.WinForms.Button()
        
        '@design Me.TrayHeight = 0
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        lst.Location = New System.Drawing.Point(8, 40)
        lst.Size = New System.Drawing.Size(176, 160)
        lst.TabIndex = 0
        lst.Anchor = System.WinForms.AnchorStyles.All
        
        cmdDemarrer.Location = New System.Drawing.Point(56, 8)
        cmdDemarrer.Size = New System.Drawing.Size(75, 23)
        cmdDemarrer.TabIndex = 1
        cmdDemarrer.Anchor = System.WinForms.AnchorStyles.TopLeftRight
        cmdDemarrer.Text = "Dmarrer"
        
        Me.Text = "Synchronisation"
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(192, 213)
        
        Me.Controls.Add(cmdDemarrer)
        Me.Controls.Add(lst)
    End Sub
    
#End Region
    
    Protected Sub cmdDemarrer_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        thrCalcul.Start()
        thrExploite.Start()
    End Sub
    
    ' Le thread de calcul
    Private Sub Calcul()
        Do While True
            ' Attend le mutex
            MonMutex.WaitOne()
            
            Dim i As Integer
            Dim Total As Double = 0
            ' Remplit le tableau
            For i = 1 To 1000
                Tableau(i) = Rnd
                Total += Tableau(i)
            Next
            ' Ajuste pour que le total soit 100
            Dim TotalTemp As Double = 0
            For i = 1 To 999
                Tableau(i) /= Total
                Tableau(i) *= 100
                TotalTemp += Tableau(i)
            Next
            ' et le dernier
            Tableau(1000) = 100 - TotalTemp
            
            ' Relche le mutex
            MonMutex.ReleaseMutex()
        Loop
    End Sub
    
    ' Le thread d'exploitation des donnes
    Private Sub Exploite()
        Do While True
            ' Attend le mutex
            MonMutex.WaitOne()
            
            Dim i As Integer
            Dim Total As Double = 0
            For i = 1 To 1000
                Total += Tableau(i)
            Next
            
            ' Relche le mutex
            MonMutex.ReleaseMutex()
            
            ' Affiche le total
            lst.Items.Add(Total.ToString)
            lst.SelectedIndex = lst.Items.Count - 1
            
            ' Attend un peu
            Thread.Sleep(1000)
        Loop
    End Sub
End Class
